!!! common function with drv to be called by other functions directly

    subroutine outputChannel(segInfoFile,CHMann_m,BOTWID_m,CHAN_SS_m,nlinks)
       implicit none
#include <netcdf.inc>
       integer, dimension(1) :: dim1
       integer, dimension(2) :: dim2
       integer :: ncid, iret, idim_id, jdim_id, node_id, varid
       character(len=50) vname
       character(len=*) :: segInfoFile
       integer :: nlinks
       real,dimension(nlinks) :: CHMann_m,BOTWID_m,CHAN_SS_m


       iret = nf_open(trim(segInfoFile), NF_WRITE, ncid)

       iret = nf_inq_varid(ncid,"CHMann_m",varid)
       iret = nf_put_var_real(ncid,varid,CHMann_m)

       iret = nf_inq_varid(ncid,"CHAN_SS_m",varid)
       iret = nf_put_var_real(ncid,varid,CHAN_SS_m)

       iret = nf_inq_varid(ncid,"BOTWID_m",varid)
       iret = nf_put_var_real(ncid,varid,BOTWID_m)

       iret=nf_close(ncid)
    end subroutine outputChannel

  subroutine getAttInt(inFile,var,outNumb)
       implicit none
#include <netcdf.inc>
       integer :: outNumb
       character(len=*) :: inFile, var
       integer :: iret, ncid, varid
       iret = nf_open(trim(inFile), NF_NOWRITE, ncid)
       if(iret .ne. 0) then
            write(6,*)  "Error: failed to open file: ", trim(inFile)
            call hydro_stop("failed in getAttnInt")
       endif
       iret = nf_get_att_int(ncid, NF_GLOBAL, trim(var), outNumb)
       iret = nf_close(ncid)
  end subroutine getAttInt

     subroutine get_1d_int_file(inFile, varName, var,nsize)
            implicit none
#include <netcdf.inc>
            integer                            :: ncid !! the file identifier
            character(len=*),      intent(in)  :: varName
            integer, dimension(nsize), intent(out) :: var
            character(len=*),      intent(in)  :: inFile
            integer :: varid, iret, nsize
            iRet = nf_open(trim(inFile), nf_nowrite, ncid)
            iRet = nf_inq_varid(ncid, varName, varid)
            if (iret /= 0) then
                  write(6,*)   "Error:  get_1d_netcdf_real: variable: " // trim(varName)
                  call hydro_stop()
            end if
            iRet = nf_get_var_int(ncid, varid, var )
            if (iRet /= 0) then
               write(6,*)  "Error: get_1d_netcdf_int: values: " // trim(varName)
               call hydro_stop()
            end if
            iret = nf_close(ncid)
       end subroutine get_1d_int_file  

     subroutine get_1d_real_file(inFile, varName, var,nsize)
            implicit none
#include <netcdf.inc>
            integer                            :: ncid !! the file identifier
            character(len=*),      intent(in)  :: varName
            real, dimension(nsize), intent(out) :: var
            character(len=*),      intent(in)  :: inFile
            integer :: varid, iret, nsize
            iRet = nf_open(trim(inFile), nf_nowrite, ncid)
            iRet = nf_inq_varid(ncid, varName, varid)
            if (iret /= 0) then
                  write(6,*)   "Error:  get_1d_netcdf_real: variable: " // trim(varName)
                  call hydro_stop()
            end if
            iRet = nf_get_var_real(ncid, varid, var )
            if (iRet /= 0) then
               write(6,*)  "Error: get_1d_netcdf_int: values: " // trim(varName)
               call hydro_stop()
            end if
            iret = nf_close(ncid)
       end subroutine get_1d_real_file


          subroutine get_file_dimension0(fileName, var, nsize)
            implicit none
#include <netcdf.inc>
            character(len=*)::  fileName, var
            integer :: ncid , iret, nsize, dimid
            iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
            if (iret /= 0) then
               write(6,*) "In get_file_dimension() - Problem opening file",trim(fileName)
               call hydro_stop("stopped")
            endif
            iret = nf_inq_dimid(ncid, trim(var), dimid)
            if (iret /= 0) then
               write(6,*) "In get_file_dimension() - nf_inq_dimid: ",trim(var),trim(fileName)
               call hydro_stop("stopped")
            endif

            iret = nf_inq_dimlen(ncid, dimid, nsize)
            if (iret /= 0) then
               write(6,*) "In get_file_dimension() - nf_inq_dimlen:m",trim(var),trim(fileName)
               call hydro_stop("stopped")
            endif

            iret = nf_close(ncid)
          end subroutine get_file_dimension0
          

      subroutine MPP_LAND_COM_REAL_rami(in_out_data,NX,NY,flag)
         use module_mpp_land, only: MPP_LAND_COM_REAL
         implicit none
         integer :: NX,NY,flag
         real,dimension(:,:) :: in_out_data
         call MPP_LAND_COM_REAL(in_out_data,NX,NY,flag)
      end subroutine MPP_LAND_COM_REAL_rami


      subroutine decompose_RT_real_rami (in_buff,out_buff,g_nx,g_ny,nx,ny,ii,jj)
         use module_mpp_land, only: decompose_RT_real
         implicit none
         integer g_nx,g_ny,nx,ny, ii,jj
         real,intent(in),dimension(ii,jj) :: in_buff
         real,intent(out),dimension(nx,ny) :: out_buff
         integer tag, i, status, ierr,size
         integer ibegin,iend,jbegin,jend
!        write(6,*) " ii,jj",ii,jj
!        write(6,*) "nx, ny", nx,ny
!         
            call decompose_RT_real (in_buff,out_buff,g_nx,g_ny,nx,ny)
      end subroutine decompose_RT_real_rami
      subroutine mpp_land_bcast_char_rami(size,inout)
         use module_mpp_land, only:mpp_land_bcast_char
         implicit none
         integer size
         character inout(*)
         integer ierr
         call mpp_land_bcast_char(size,inout)
      end subroutine mpp_land_bcast_char_rami


 subroutine ramiBdyUpdateDrvHydro(QSTRMVOLRT)
     use module_mpp_land, only : my_id, io_id, global_rt_nx, global_rt_ny, local_rt_nx, local_rt_ny
     use module_namelist, only:  nlst_rt
    implicit none 
     integer :: did
     real, dimension(local_rt_nx,local_rt_ny)  :: QSTRMVOLRT
     did = 1
     call ramiBdyUpdateDrv(QSTRMVOLRT,my_id, io_id, global_rt_nx, global_rt_ny, local_rt_nx, local_rt_ny, nlst_rt(did)%dtrt_ch,nlst_rt(did)%oldDate)
 end subroutine ramiBdyUpdateDrvHydro

!!! for lake
subroutine ramiUpdateIniH()
!    This update the lake initial elevation
     use module_rt_data, only: rt_domain
     implicit none
     if(rt_domain(1)%nlakes .gt. 0 ) then
         call updateIniHDrv(rt_domain(1)%RESHT,rt_domain(1)%nlakes)
     endif
end subroutine ramiUpdateIniH

!! for lake

       subroutine rami_update_lake_sfch_drv()
!       This is called after disaggregation
          use module_rt_data, only: rt_domain
          use module_namelist, only:  nlst_rt
!          use module_NoahMP_hrldas_driver, only: RAINBL
          use module_mpp_land, only: io_id, my_id
         implicit none
          if( rt_domain(1)%NLAKES .le. 0) return
          call  update_lake_sfch0(nlst_rt(1)%olddate, rt_domain(1)%ELEVLAKE, rt_domain(1)%nlakes,&
                rt_domain(1)%ixrt,rt_domain(1)%jxrt, rt_domain(1)%dist_lsm(:,:,9),   &
                rt_domain(1)%dist(:,:,9), nlst_rt(1)%AGGFACTRT , rt_domain(1)%ix,rt_domain(1)%jx, &
                rt_domain(1)%LAKE_MSKRT,rt_domain(1)%INFXSUBRT,rt_domain(1)%SFCHEADSUBRT, &
                rt_domain(1)%RAINBL, io_id, my_id)

       end subroutine rami_update_lake_sfch_drv

       subroutine rami_lake_lateral_in_drv()
!       This is called after terrain routing and bucket, before drive the channel routing code.
          use module_rt_data, only: rt_domain
          use module_namelist, only:  nlst_rt
          implicit none
          call rami_lake_lateral_in_drv0(rt_domain(1)%ixrt, rt_domain(1)%jxrt,&
               rt_domain(1)%LAKE_MSKRT,rt_domain(1)%LAKE_INFLORT_TS,rt_domain(1)%dist(:,:,9),&
               nlst_rt(1)%DT)
       end subroutine rami_lake_lateral_in_drv

       subroutine output_lakes_rami_drv(date)
          use module_rt_data, only: rt_domain
          use module_namelist, only:  nlst_rt
          use module_mpp_land, only: my_id, io_id
          implicit none
          character(len=19) :: date
          call output_lakes_rami_drv1(date,rt_domain(1)%ixrt,rt_domain(1)%jxrt,&
                 rt_domain(1)%latlake, rt_domain(1)%lonlake, rt_domain(1)%elevlake, &
                 rt_domain(1)%qlakei,rt_domain(1)%qlakeo, rt_domain(1)%resht,my_id,io_id)
       end subroutine output_lakes_rami_drv

    subroutine rami_output_staticData_drv()
        use module_rt_data, only: rt_domain
        use module_mpp_land, only: my_id, io_id ,global_rt_nx, global_rt_ny, global_nx, global_ny, &
                     write_chanel_real, write_chanel_int
        implicit none
#include <netcdf.inc>
         integer :: i,j, ii,jj, nlinks
         integer :: ncid, iret, dimid_n, varid, dimIdStnStr
         real, allocatable, dimension(:,:) :: tmpREFKDT, tmpBE
         character(len=15), allocatable, dimension(:) :: tmpChar
         character(len=256) :: out_seg_file
         integer :: dimid_ix, dimid_jx, dimid_ixrt, dimid_jxrt, to
         real, dimension(rt_domain(1)%nlinks):: tmpChlat,tmpChlon
         integer, allocatable, dimension(:) :: g_order, g_chanxi, g_chanyj, g_l_gid, g_to_node_gid, g_tmpInt, g_LAKENODE, g_seg2m
         real, allocatable, dimension(:) :: g_chlat, g_chlon, g_tmpReal
         integer, allocatable,dimension(:,:) :: g_rtMsk, g_lndMsk
         integer :: did
         parameter (did = 1)

       


 

        open(65,file="staticData.txt",form="formatted")

      
         if(my_id .eq. io_id) then
            allocate(g_order(rt_domain(did)%gnlinks))
            allocate(g_chanxi(rt_domain(did)%gnlinks))
            allocate(g_chanyj(rt_domain(did)%gnlinks))
            allocate(g_l_gid(rt_domain(did)%gnlinks))
            allocate(g_to_node_gid(rt_domain(did)%gnlinks))
            allocate(g_chlat(rt_domain(did)%gnlinks))
            allocate(g_chlon(rt_domain(did)%gnlinks))
            allocate(g_tmpInt(rt_domain(did)%gnlinks))
            allocate(g_tmpReal(rt_domain(did)%gnlinks))
            allocate(g_LAKENODE(rt_domain(did)%gnlinks))
            allocate(g_rtMsk(global_rt_nx, global_rt_ny))
            allocate(g_lndMsk(global_nx, global_ny  ))
            allocate(g_seg2m(rt_domain(did)%gnlinks))

         else
            allocate(g_rtMsk(1,1))
            allocate(g_lndMsk(1,1))
            allocate(g_tmpInt(1))
            allocate(g_tmpreal(1))
            allocate(g_chlat(1))
            allocate(g_chlon(1))
            allocate(g_order(1))
            allocate(g_chanxi(1))
            allocate(g_chanyj(1))
            allocate(g_l_gid(1))
            allocate(g_LAKENODE(1))
            allocate(g_to_node_gid(1))
            allocate(g_seg2m(1))
         endif 

         call write_chanel_real(rt_domain(did)%chlat,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chlat)
         call write_chanel_real(rt_domain(did)%chlon,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chlon)
         call write_chanel_int(rt_domain(did)%order,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_order)
         call write_chanel_int(rt_domain(did)%l_gi,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chanxi)
         call write_chanel_int(rt_domain(did)%l_gj,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chanyj)
         call write_chanel_int(rt_domain(did)%l_gid,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_l_gid)
         call write_chanel_int(rt_domain(did)%to_node_gid,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_to_node_gid)
         call write_chanel_int(rt_domain(did)%LAKENODE,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_LAKENODE)




         if(my_id .eq. io_id) then 
            call chrt_io_switch_int(g_Chlat,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_Chlon,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_order,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_chanxi,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_chanyj,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_LAKENODE,g_l_gid,rt_domain(did)%gnlinks)
            call chrt_io_switch_int(g_to_node_gid,g_l_gid,rt_domain(did)%gnlinks)
            g_seg2m =  -999
            do i = 1, rt_domain(did)%gnlinks
                 if(g_l_gid(i) .gt. 0) then
                    g_seg2m(g_l_gid(i)) = i
                 endif
            enddo
            g_tmpInt = g_l_gid
            call chrt_io_switch_int(g_l_gid,g_tmpInt,rt_domain(did)%gnlinks)
         endif

     if(my_id .eq. io_id ) then 
        do i = 1, rt_domain(did)%gnlinks
            to = g_TO_NODE_gid(i)
            if(to .gt. 0) then 
                 write(65,221) g_chlat(i),g_chlon(i), g_order(i), &
                      g_CHANXI(i), g_CHANYJ(i),to, &
                      g_l_gid(i) 
            else
                 write(65,221) g_chlat(i),g_chlon(i), g_order(i), &
                      g_CHANXI(i), g_CHANYJ(i),-9999, &
                      g_l_gid(i) 
            endif
        end do
        close(65)
      endif
221   format(2f12.6,i3,2i6,2i8)

!         call write_chanel_real(rt_domain(did)%chlat,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chlat)
!         call write_chanel_real(rt_domain(did)%chlon,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chlon)
!         call write_chanel_int(rt_domain(did)%order,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_order)
!         call write_chanel_int(rt_domain(did)%l_gi,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chanxi)
!         call write_chanel_int(rt_domain(did)%l_gj,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_chanyj)
!         call write_chanel_int(rt_domain(did)%l_gid,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_l_gid)
!         call write_chanel_int(rt_domain(did)%to_node_gid,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_to_node_gid)

!!! output the netcdf file as a template       
     if(my_id .eq. io_id) then
       out_seg_file="seg_info.nc"
       iret = nf_create(trim(out_seg_file), NF_CLOBBER, ncid) 

       iret = nf_def_dim(ncid, "n", rt_domain(did)%gnlinks, dimid_n)

       iret = nf_def_dim(ncid, "ixrt", global_rt_nx, dimid_ixrt)
       iret = nf_def_dim(ncid, "jxrt", global_rt_ny, dimid_jxrt)
       iret = nf_def_dim(ncid, "ix", global_nx, dimid_ix)
       iret = nf_def_dim(ncid, "jx", global_ny, dimid_jx)

       iret = nf_def_var(ncid,"seg_maskRt2d",NF_INT, 2, (/dimid_ixrt,dimid_jxrt/), varid)
       iret = nf_def_var(ncid,"seg_masklnd2d",NF_INT, 2, (/dimid_ix,dimid_jx/), varid)

       iret = nf_def_var(ncid,"BOTWID_m",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"BOTWID_m_av",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"n_BOTWID_m_av",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')

       iret = nf_def_var(ncid,"CHMann_m",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"CHMann_m_av",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"n_CHMann_m_av",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')


       iret = nf_def_var(ncid,"CHAN_SS_m",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"CHAN_SS_m_av",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')
       iret = nf_def_var(ncid,"n_CHAN_SS_m_av",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, model domain')

       iret = nf_def_var(ncid,"chlat",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, global domain')
       iret = nf_def_var(ncid,"chlon",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'_m, global domain')
       iret = nf_def_var(ncid,"stationlat",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_def_var(ncid,"stationlon",NF_FLOAT, 1, (/dimid_n/), varid)
       iret = nf_def_var(ncid,"from_node",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')
       iret = nf_def_var(ncid,"to_node",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')
       iret = nf_def_var(ncid,"chanxi",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')
       iret = nf_def_var(ncid,"chanyj",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')
       iret = nf_def_var(ncid,"order",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')

       iret = nf_def_var(ncid,"LAKENODE",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',27,'lake in node, global domain')

       iret = nf_def_var(ncid,"station_mask",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')
       iret = nf_def_var(ncid,"to_seg",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'   global domain')

       iret = nf_def_var(ncid,"lake2seg",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_def_var(ncid,"id_lake2seg",NF_INT, 1, (/dimid_n/), varid)

       iret = nf_def_var(ncid,"seg_lake_count",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_def_var(ncid,"seg",NF_INT, 1, (/dimid_n/), varid)

       iret = nf_def_var(ncid,"stationi",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'not used ?      ')
       iret = nf_def_var(ncid,"stationj",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',16,'not used ?      ')
       iret = nf_def_var(ncid,"obsList",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_def_var(ncid,"station_id",NF_INT, 1, (/dimid_n/), varid)


       iret = nf_def_var(ncid,"m2seg",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_text(ncid,varid,'description',28,'index is model, value is seg')
       iret = nf_def_var(ncid,"seg2m",NF_INT, 1, (/dimid_n/), varid)
       iret = nf_put_att_int(ncid, NF_GLOBAL, 'obs_num', NF_INT, 1, 0)
       iret = nf_put_att_text(ncid,varid,'description',28,'index is seg, value is model')

       iret = nf_enddef(ncid)

          g_rtMsk = -999
          iret = nf_inq_varid(ncid,"seg_maskRt2d", varid)
          iret = nf_put_var_int(ncid,varid,g_rtMsk)

          g_lndMsk = -999
          iret = nf_inq_varid(ncid,"seg_masklnd2d", varid)
          iret = nf_put_var_int(ncid,varid,g_lndMsk)
       endif

       ! write(6,*)  "Bw = ", rt_domain(did)%Bw   
       ! write(6,*)  "ChSSlp = ", rt_domain(did)%ChSSlp
       ! write(6,*)  "MannN  = ", rt_domain(did)%MannN  

       call write_chanel_real(rt_domain(did)%BW,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_tmpReal)
       if(my_id .eq. io_id)  then 
          iret = nf_inq_varid(ncid,"BOTWID_m", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)
          iret = nf_inq_varid(ncid,"BOTWID_m_av", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)
          g_tmpInt = 0
          iret = nf_inq_varid(ncid,"n_BOTWID_m_av", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)
       endif

       call write_chanel_real(rt_domain(did)%MannN,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_tmpReal)
       if(my_id .eq. io_id)  then 
          iret = nf_inq_varid(ncid,"CHMann_m", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)
          iret = nf_inq_varid(ncid,"CHMann_m_av", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)

          g_tmpInt = 0
          iret = nf_inq_varid(ncid,"n_CHMann_m_av", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)
       endif

       call write_chanel_real(rt_domain(did)%ChSSlp,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,rt_domain(did)%nlinks,g_tmpReal)
       if(my_id .eq. io_id)  then 
          iret = nf_inq_varid(ncid,"CHAN_SS_m", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)
          iret = nf_inq_varid(ncid,"CHAN_SS_m_av", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)

          g_tmpInt = 0
          iret = nf_inq_varid(ncid,"n_CHAN_SS_m_av", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)
       endif

       if(my_id .eq. io_id)  then 
       

          iret = nf_inq_varid(ncid,"m2seg", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)
          iret = nf_inq_varid(ncid,"seg2m", varid)
          iret = nf_put_var_int(ncid,varid,g_seg2m)

          g_tmpInt = -9999
          g_tmpReal = -9999

          iret = nf_inq_varid(ncid,"stationlat", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)
          iret = nf_inq_varid(ncid,"stationlon", varid)
          iret = nf_put_var_real(ncid,varid,g_tmpReal)

          iret = nf_inq_varid(ncid,"to_seg", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"seg_lake_count", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"lake2seg", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"id_lake2seg", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"seg", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"stationi", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"stationj", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"station_id", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"obsList", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"station_mask", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"chlat", varid)
          iret = nf_put_var_real(ncid,varid,g_chlat)
          iret = nf_inq_varid(ncid,"chlon", varid)
          iret = nf_put_var_real(ncid,varid,g_chlon)
          iret = nf_inq_varid(ncid,"chanxi", varid)
          iret = nf_put_var_int(ncid,varid,g_chanxi)
          iret = nf_inq_varid(ncid,"chanyj", varid)
          iret = nf_put_var_int(ncid,varid,g_chanyj)
          iret = nf_inq_varid(ncid,"order", varid)
          iret = nf_put_var_int(ncid,varid,g_order)
          iret = nf_inq_varid(ncid,"from_node", varid)
          iret = nf_put_var_int(ncid,varid,g_l_gid)
          iret = nf_inq_varid(ncid,"to_node", varid)
          iret = nf_put_var_int(ncid,varid,g_to_node_gid)

          iret = nf_inq_varid(ncid,"LAKENODE", varid)
          iret = nf_put_var_int(ncid,varid,g_LAKENODE)

       endif


       if(my_id .eq. io_id)  then 
          iret = nf_close(ncid)
       endif


      
!!!!   output the be and refkdt file 
     if(my_id .eq. io_id) then
       out_seg_file="dabe.nc"
       iret = nf_create(trim(out_seg_file), NF_CLOBBER, ncid) 


!       iret = nf_def_dim(ncid, "ixrt", global_rt_nx, dimid_ixrt)
!       iret = nf_def_dim(ncid, "jxrt", global_rt_ny, dimid_jxrt)
!       iret = nf_def_dim(ncid, "ix", global_nx, dimid_ix)
!       iret = nf_def_dim(ncid, "jx", global_ny, dimid_jx)
!       iret = nf_def_var(ncid,"refkdt_2d",NF_FLOAT, 2, (/dimid_ix,dimid_jx/), varid)
!       iret = nf_def_var(ncid,"be",NF_FLOAT, 2, (/dimid_ixrt,dimid_jxrt/), varid)

               iret = nf_def_dim(ncid, "nlinks", rt_domain(did)%gnlinks,dimid_n)
               iret = nf_def_var(ncid,"bias_m",NF_FLOAT,1,(/dimid_n/),varid)
               iret = nf_put_att_text(ncid,varid,'description:',21,'model used bias m^3/s')
               iret = nf_def_var(ncid,"bias_m_av",NF_FLOAT,1,(/dimid_n/),varid)
               iret = nf_put_att_text(ncid,varid,'description:',29,'averaged           bias m^3/s')
               iret = nf_def_var(ncid,"n_bias_av",NF_INT,1,(/dimid_n/),varid)
               iret = nf_put_att_text(ncid,varid,'description:',29,'number for averaged bias     ')
               iret = nf_def_var(ncid,"seg_points",NF_INT,1,(/dimid_n/),varid)
               iret = nf_put_att_text(ncid,varid,'description:',29,'total points for this segment')

       iret = nf_enddef(ncid)

!       iret = nf_inq_varid(ncid,"be", varid)
!       iret = nf_put_var_real(ncid,varid,g_rtMsk)

!       iret = nf_inq_varid(ncid,"refkdt_2d", varid)
!       iret = nf_put_var_real(ncid,varid,g_lndMsk)

        g_tmpInt = 0
          iret = nf_inq_varid(ncid,"seg_points", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)

          iret = nf_inq_varid(ncid,"n_bias_av", varid)
          iret = nf_put_var_int(ncid,varid,g_tmpInt)


        g_tmpReal = 0.0
        iret = nf_inq_varid(ncid,"bias_m_av", varid)
        iret = nf_put_var_real(ncid,varid,g_tmpReal)

        iret = nf_inq_varid(ncid,"bias_m", varid)
        iret = nf_put_var_real(ncid,varid,g_tmpReal)

       iret = nf_close(ncid)
    endif

       deallocate(g_order, g_chanxi, g_chanyj, g_l_gid, g_to_node_gid, g_tmpReal, g_tmpInt)
       deallocate(g_rtMsk, g_lndMsk)


      !   call dumphead()


       call hydro_finish()

    end subroutine rami_output_staticData_drv

    subroutine ramisum_real8(vin,nsize)
         use module_mpp_land, only: sum_real8
         implicit none
         integer :: nsize
         real*8,dimension(nsize):: vin
         call sum_real8(vin,nsize)
    end subroutine ramisum_real8

    subroutine ramimpp_land_sync
         use module_mpp_land, only: mpp_land_sync
         implicit none
         call mpp_land_sync()
    end subroutine ramimpp_land_sync

 
       subroutine rami_mpp_output_chrt_drv()
! replace the mpp_output_chrt
         use module_namelist, only: nlst_rt
         use module_rt_data, only: rt_domain
         implicit none
         integer :: did 
         did = 1 
        
          call mpp_output_chrt0(rt_domain(did)%gnlinks,rt_domain(did)%map_l2g, &
               RT_DOMAIN(did)%NLINKS,RT_DOMAIN(did)%NLINKS,RT_DOMAIN(did)%ORDER, &
               nlst_rt(did)%sincedate,nlst_rt(did)%olddate,RT_DOMAIN(did)%CHLON,&
               RT_DOMAIN(did)%CHLAT, &
               RT_DOMAIN(did)%HLINK, RT_DOMAIN(did)%CVOL, RT_DOMAIN(did)%ZELEV, &
               RT_DOMAIN(did)%QLINK,nlst_rt(did)%DT, &
               rt_domain(did)%qlinkMax, rt_domain(did)%accqlinkMax , rt_domain(did)%l_gid,nlst_rt(did)%igrid ) 
       end subroutine rami_mpp_output_chrt_drv

   subroutine mpp_output_chrt0(gnlinks,map_l2g,&
        NLINKS, snlinks,ORDER, &
        startdate, date, chlon, chlat, hlink,cvol, zelev,qlink,dtrt, qlinkMax, accqlinkMax, gid,igrid)
        

       USE module_mpp_land
       use module_rt_data, only: rt_domain
       use module_namelist, only:  nlst_rt
       implicit none
       integer :: did
       parameter(did=1)

!!output the routing variables over just channel
     integer                                              :: igrid,K
     integer                                              :: split_output_count
     integer,                                  intent(in) :: NLINKS, snlinks
     real, dimension(snlinks),               intent(in) :: chlon,chlat, hlink,zelev, cvol

     integer, dimension(snlinks),               intent(in) :: ORDER

     real,                                     intent(in) :: dtrt
     real, dimension(snlinks,2),                intent(in) :: qlink
     real, dimension(sNLINKS) :: tmpLink
     real, dimension(snlinks)  :: qlinkmax, accqlinkmax

     character(len=*),                         intent(in) :: startdate
     character(len=*),                         intent(in) :: date

     integer  :: gnlinks, map_l2g(nlinks), order_to_write
     integer, dimension(nlinks) :: gid
     !real, dimension(gNLINKS) :: g_chlon,g_chlat, g_hlink,g_zelev, g_cvol
     !real, dimension(gNLINKS,2) :: g_qlink
     !integer ,  dimension(gNLINKS) :: g_order
      real, allocatable,dimension(:) :: g_chlon,g_chlat, g_hlink,g_zelev, g_cvol
      integer, allocatable,dimension(:) :: g_order, g_gid
      real,allocatable,dimension(:,:) :: g_qlink
      real, allocatable, dimension(:)  :: g_qlinkmax, g_accqlinkmax
      integer, allocatable, dimension(:)  :: g_chFloodMsk, g_chFloodMsk_acc

     split_output_count = 1 
!     igrid = 0
     order_to_write = 1

     if(my_id .eq. io_id ) then
        allocate(g_chlon(gNLINKS))
        allocate(g_chlat(gNLINKS))
        allocate(g_hlink(gNLINKS))
        allocate(g_cvol(gNLINKS))
        allocate(g_zelev(gNLINKS))
        allocate(g_qlink(gNLINKS,2))
        allocate(g_order(gNLINKS))
        allocate(g_accqlinkMax(gNLINKS))
        allocate(g_qlinkMax(gNLINKS))
        allocate(g_gid(gNLINKS))
        allocate(g_chFloodMsk(gNLINKS))
        allocate(g_chFloodMsk_acc(gNLINKS))
     else
        allocate(g_chlon(1))
        allocate(g_chlat(1))
        allocate(g_hlink(1))
        allocate(g_cvol(1))
        allocate(g_zelev(1))
        allocate(g_qlink(1,2))
        allocate(g_order(1))
        allocate(g_accqlinkMax(1))
        allocate(g_qlinkMax(1))
        allocate(g_gid(1))
   
        allocate(g_chFloodMsk(1))
        allocate(g_chFloodMsk_acc(1))
     endif
        g_chFloodMsk = -9999
        g_chFloodMsk_acc = -9999


     call write_chanel_int(gid,map_l2g,gnlinks,nlinks,g_gid)

     call write_chanel_int(order,map_l2g,gnlinks,nlinks,g_order)
     if(my_id .eq. io_id) call chrt_io_switch_int(g_order,g_gid,gnlinks)

     call write_chanel_real(chlon,map_l2g,gnlinks,nlinks,g_chlon)

     call write_chanel_real(chlat,map_l2g,gnlinks,nlinks,g_chlat)

     if(my_id .eq. io_id) call chrt_io_switch_real(g_chlon,g_gid,gnlinks)
     if(my_id .eq. io_id) call chrt_io_switch_real(g_chlat,g_gid,gnlinks)

     call write_chanel_real(hlink,map_l2g,gnlinks,nlinks,g_hlink)
     if(my_id .eq. io_id) call chrt_io_switch_real(g_hlink,g_gid,gnlinks)

     call write_chanel_real(cvol,map_l2g,gnlinks,nlinks,g_cvol)
     if(my_id .eq. io_id) call chrt_io_switch_real(g_cvol,g_gid,gnlinks)

     call write_chanel_real(zelev,map_l2g,gnlinks,nlinks,g_zelev)
     if(my_id .eq. io_id) call chrt_io_switch_real(g_zelev,g_gid,gnlinks)

     call write_chanel_real(qlink(:,1),map_l2g,gnlinks,nlinks,g_qlink(:,1))
     if(my_id .eq. io_id) call chrt_io_switch_real(g_qlink(:,1),g_gid,gnlinks)

     call write_chanel_real(qlink(:,2),map_l2g,gnlinks,nlinks,g_qlink(:,2))
     if(my_id .eq. io_id) call chrt_io_switch_real(g_qlink(:,2),g_gid,gnlinks)

     call write_chanel_real(qlinkMax(:),map_l2g,gnlinks,nlinks,g_qlinkMax(:))
     if(my_id .eq. io_id) call chrt_io_switch_real(g_qlinkMax,g_gid,gnlinks)

     where(qlinkMax .gt. accqlinkMax) accqlinkMax = qlinkMax
     call write_chanel_real(accqlinkMax(:),map_l2g,gnlinks,nlinks,g_accqlinkMax(:))
     qlinkMax = 0
     if(my_id .eq. io_id) call chrt_io_switch_real(g_accqlinkMax,g_gid,gnlinks)

     if(nlst_rt(did)%overbank .gt. 0) then
        call write_chanel_int(rt_domain(did)%chFloodMsk,map_l2g,gnlinks,nlinks,g_chFloodMsk)
        if(my_id .eq. io_id) call chrt_io_switch_real(g_chFloodMsk,g_gid,gnlinks)
        call write_chanel_int(rt_domain(did)%chFloodMsk_acc,map_l2g,gnlinks,nlinks,g_chFloodMsk_acc)
        if(my_id .eq. io_id) call chrt_io_switch_real(g_chFloodMsk_acc,g_gid,gnlinks)
     endif

     if(my_id .eq. IO_id) then
       
       call output_chrt0(igrid, split_output_count, GNLINKS, g_ORDER, &
          startdate, date, g_chlon, g_chlat, g_hlink,g_cvol,g_zelev,g_qlink,dtrt,&
          order_to_write, g_qlinkMax, g_accqlinkMax,g_chFloodMsk, g_chFloodMsk_acc )
    end if
    deallocate (g_order, g_chlon, g_chlat, g_hlink )
    deallocate ( g_cvol, g_zelev, g_qlink, g_gid )
    deallocate ( g_qlinkMax, g_accqlinkMax)

    deallocate(g_chFloodMsk, g_chFloodMsk_acc)


end subroutine mpp_output_chrt0



       subroutine rami_output_lake_drv(olddate, nlakes)
!      This is called in the regular output loop of LAKE
            use module_rt_data, only: rt_domain
            use module_mpp_land, only: my_id, io_id
            implicit none
            integer :: nlakes
            character(len=*) :: olddate
            if( NLAKES .le. 0) return
            call output_lakes_rami_drv1(olddate,rt_domain(1)%ixrt,rt_domain(1)%jxrt,&
                     rt_domain(1)%latlake, rt_domain(1)%lonlake, rt_domain(1)%elevlake, &
                     rt_domain(1)%qlakei,rt_domain(1)%qlakeo, rt_domain(1)%resht,my_id, io_id)
       end subroutine rami_output_lake_drv

       subroutine ramimpp_land_bcast_int1(inout)
           use module_mpp_land, only: mpp_land_bcast_int1
           implicit none
           integer inout
           call mpp_land_bcast_int1(inout)
       end subroutine ramimpp_land_bcast_int1

       subroutine ramimpp_land_bcast_real1(inout)
           use module_mpp_land, only: mpp_land_bcast_real1
           implicit none
           real inout
           call mpp_land_bcast_real1(inout)
       end subroutine ramimpp_land_bcast_real1
       subroutine ramimpp_land_bcast_real1d(inout,nsize)
           use module_mpp_land, only: mpp_land_bcast_real_1d
           implicit none
           integer :: nsize
           real,dimension(nsize):: inout
           call mpp_land_bcast_real_1d(inout)
       end subroutine ramimpp_land_bcast_real1d


   subroutine output_chrt0(igrid, split_output_count, NLINKS, ORDER, &
        startdate,date,chlon, chlat, hlink,cvol, zelev,qlink,dtrt, &
        order_to_write, qlinkMax, accqlinkMax, chFloodMsk, chFloodMsk_acc)
     use module_namelist, only: nlst_rt
     use module_rt_data, only: rt_domain
     implicit none
#include <netcdf.inc>
!!output the routing variables over just channel
     integer,                                  intent(in) :: igrid
     integer,                                  intent(in) :: split_output_count
     integer,                                  intent(in) :: NLINKS
     real, dimension(NLINKS),                  intent(in) :: chlon,chlat
     real, dimension(NLINKS),                  intent(in) :: hlink,zelev, cvol
     integer, dimension(NLINKS),               intent(in) :: ORDER
     integer, dimension(NLINKS),               intent(in) :: chFloodMsk, chFloodMsk_acc

     real,                                     intent(in) :: dtrt
     real, dimension(NLINKS,2),                intent(in) :: qlink
     real, dimension(NLINKS),                  intent(in) :: qlinkMax, accqlinkMax

     character(len=19),                         intent(in) :: startdate
     character(len=19),                         intent(in) :: date

     real, allocatable, DIMENSION(:)            :: chanlat,chanlon

     real, allocatable, DIMENSION(:)            :: elevation

     integer, allocatable, DIMENSION(:)         :: station_id

     integer, allocatable, DIMENSION(:)         :: rec_num_of_station

     integer, allocatable, DIMENSION(:)         :: lOrder !- local stream order

     integer, save  :: output_count
     integer, save  :: ncid

     integer :: stationdim, dimdata, varid, charid, n
     integer :: obsdim, dimdataO, charidO

     integer :: iret,i, start_pos, order_to_write!-- order_to_write is the lowest stream order to output

     integer :: previous_pos  !-- used for the station model
     character(len=256) :: output_flnm,output_flnm2
     character(len=19)  :: date19,date19start
     character(len=34)  :: sec_since_date
     integer :: nstations,cnt

    !--- all this for writing the station id string
     INTEGER   TDIMS, TXLEN
     PARAMETER (TDIMS=2)    ! number of TX dimensions
     PARAMETER (TXLEN = 11) ! length of example string
     INTEGER  TIMEID        ! record dimension id
     INTEGER  TXID          ! variable ID
     INTEGER  TXDIMS(TDIMS) ! variable shape
     INTEGER  TSTART(TDIMS), TCOUNT(TDIMS)

     !--  observation point  ids
     INTEGER   OTDIMS, OTXLEN
     PARAMETER (OTDIMS=2)    ! number of TX dimensions
     PARAMETER (OTXLEN = 11) ! length of example string
     INTEGER  OTIMEID        ! record dimension id
     INTEGER  OTXID          ! variable ID
     INTEGER  OTXDIMS(OTDIMS) ! variable shape
     INTEGER  OTSTART(OTDIMS), OTCOUNT(OTDIMS)

     integer  :: st_index, timedim, seconds_since
     real     :: st_lon, st_lat
     character (len = 256) :: st_name
     logical :: fexist
     character(len=32)  :: convention
     character(len=34) :: sec_valid_date
     integer :: did
     parameter(did=1)


      nstations = 0  ! total number of channel points to display

!-- output only the higher oder streamflows  and only observation points
       do i=1,NLINKS
        if(ORDER(i) .ge. order_to_write) then 
         nstations = nstations + 1
        endif
       enddo 


       allocate(chanlat(nstations))
       allocate(chanlon(nstations))
       allocate(elevation(nstations))
       allocate(station_id(nstations))
       allocate(lOrder(nstations))
       allocate(rec_num_of_station(nstations))

       do i =1, nstations
         station_id(i) = i
       end do

       if(output_count == 0) then 
!-- have moved sec_since_date from above here..
        sec_since_date = 'seconds since '//startdate(1:4)//'-'//startdate(6:7)//'-'//startdate(9:10) &
                  //' '//startdate(12:13)//':'//startdate(15:16)//' UTC'

        date19start(1:len_trim(startdate)) = startdate(1:4)//'-'//startdate(6:7)//'-'//startdate(9:10)//'_' &
                  //startdate(12:13)//':'//startdate(15:16)//':00'

        nstations = 0

        write(output_flnm, '(A12,".CHRTOUT_DOMAIN",I1)') date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16), igrid


!#ifdef WRFIO_NCD_LARGE_FILE_SUPPORT
!       iret = nf_create(trim(output_flnm), IOR(NF_CLOBBER,NF_64BIT_OFFSET), ncid)
!#else
       iret = nf_create(trim(output_flnm), NF_CLOBBER, ncid)
!#endif
        if (iret /= 0) then
           write(6,*)   "Problem nf_create points"
           call hydro_stop("output_chrt")
        endif
        if (iret /= 0) then
            write(6,*)  "Problem nf_create observation"
            call hydro_stop("output_chrt")
        endif


       do i=1,NLINKS
         nstations = nstations + 1
         chanlat(nstations) = chlat(i)
         chanlon(nstations) = chlon(i)
         elevation(nstations) = zelev(i)
         lOrder(nstations) = ORDER(i)
         station_id(nstations) = i
       enddo 


!       iret = nf_def_dim(ncid, "recNum", NF_UNLIMITED, dimdata)
       iret = nf_def_dim(ncid, "size", nstations, dimdata)

!       iret = nf_def_dim(ncid, "station", nstations, stationdim)
       iret = nf_def_dim(ncid, "time", 1, timedim)



      !- station location definition all,  lat
        iret = nf_def_var(ncid,"latitude",NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'long_name',8,'Latitude')
        iret = nf_put_att_text(ncid,varid,'units',13,'degrees north')


      !- station location definition,  long
        iret = nf_def_var(ncid,"longitude",NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'long_name',9,'Longitude')
        iret = nf_put_att_text(ncid,varid,'units',12,'degrees east')




!     !-- elevation is ZELEV
        iret = nf_def_var(ncid,"altitude",NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'long_name',16,'Station altitude')
        iret = nf_put_att_text(ncid,varid,'units',6,'meters')

!-- parent index
!        iret = nf_def_var(ncid,"parent_index",NF_INT,1,(/dimdata/), varid)
!        iret = nf_put_att_text(ncid,varid,'long_name',36,'index of the station for this record')


     !-- prevChild
!        iret = nf_def_var(ncid,"prevChild",NF_INT,1,(/dimdata/), varid)
!        iret = nf_put_att_text(ncid,varid,'long_name',57,'record number of the previous record for the same station')
!       iret = nf_put_att_int(ncid,varid,'_FillValue',2,-1)


     !-- lastChild
!        iret = nf_def_var(ncid,"lastChild",NF_INT,1,(/dimdata/), varid)

!     !- flow definition, var
        iret = nf_def_var(ncid, "streamflow", NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')
        iret = nf_put_att_text(ncid,varid,'long_name',10,'streamflow')
        iret = nf_put_att_real(ncid,varid,'missing_value',NF_FLOAT,1,-9999.0)
        iret = nf_put_att_real(ncid,varid,'_FillValue',NF_FLOAT,1,-9999.0)

        iret = nf_def_var(ncid, "streamflow2d", NF_FLOAT, 1, (/dimdata,timedim/), varid)
        iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')
        iret = nf_put_att_text(ncid,varid,'long_name',10,'streamflow')
        iret = nf_put_att_real(ncid,varid,'missing_value',NF_FLOAT,1,-9999.0)
        iret = nf_put_att_real(ncid,varid,'_FillValue',NF_FLOAT,1,-9999.0)

        iret = nf_def_var(ncid, "streamflowMax", NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')
        iret = nf_put_att_text(ncid,varid,'long_name',10,'River Flow')

        iret = nf_def_var(ncid, "acc_streamflowMax", NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')
        iret = nf_put_att_text(ncid,varid,'long_name',10,'River Flow')

!     !- head definition, var
        iret = nf_def_var(ncid, "head", NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',5,'meter')
        iret = nf_put_att_text(ncid,varid,'long_name',11,'River Stage')

        iret = nf_def_var(ncid, "cvolume", NF_FLOAT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',7,'meter^3')
        iret = nf_put_att_text(ncid,varid,'long_name',14,'channel volume')

!     !- order definition, var
        iret = nf_def_var(ncid, "order", NF_INT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',7,'number ')
        iret = nf_put_att_text(ncid,varid,'long_name',14,'river order   ')

        iret = nf_def_var(ncid, "chFloodMsk", NF_INT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',7,'number ')
        iret = nf_put_att_text(ncid,varid,'long_name',14,'river flooding')

        iret = nf_def_var(ncid, "chFloodMsk_acc", NF_INT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'units',7,'number ')
        iret = nf_put_att_text(ncid,varid,'long_name',14,'river flooding')

        iret = nf_def_var(ncid, "sta", NF_INT, 1, (/dimdata/), varid)
        iret = nf_put_att_text(ncid,varid,'cf_role',13,'timeseries_id')
        iret = nf_put_att_text(ncid,varid,'long_name',7,'station')
        iret = nf_put_att_text(ncid,varid,'short_name',7,'sta')
        iret = nf_put_att_text(ncid,varid,'coordinates',7,'lat lon')


     !-- station  id
     ! define character-position dimension for strings of max length 11
         iret = NF_DEF_DIM(ncid, "id_len", 11, charid)
         TXDIMS(1) = charid   ! define char-string variable and position dimension first
         TXDIMS(2) = dimdata
         iret = nf_def_var(ncid,"station_id",NF_CHAR, TDIMS, TXDIMS, varid)
         iret = nf_put_att_text(ncid,varid,'long_name',10,'Station id')

         iret = nf_def_var(ncid,"time",NF_INT, 1, (/timedim/), varid)

         sec_valid_date = 'seconds since '//nlst_rt(1)%startdate(1:4)//'-'//nlst_rt(1)%startdate(6:7)//'-'//nlst_rt(1)%startdate(9:10) &
                   //' '//nlst_rt(1)%startdate(12:13)//':'//nlst_rt(1)%startdate(15:16)//' UTC'


         iret = nf_put_att_text(ncid,varid,'units',34,sec_valid_date)
         iret = nf_put_att_text(ncid,varid,'long_name',17,'valid output time')




         date19start(1:19) = nlst_rt(did)%startdate(1:19)
         convention(1:32) = "Unidata Observation Dataset v1.0"
         iret = nf_put_att_text(ncid, NF_GLOBAL, "Conventions",32, convention)
         iret = nf_put_att_text(ncid, NF_GLOBAL, "cdm_datatype",7, "Station")
         iret = nf_put_att_text(ncid, NF_GLOBAL, "geospatial_lat_max",4, "90.0")
         iret = nf_put_att_text(ncid, NF_GLOBAL, "geospatial_lat_min",5, "-90.0")
         iret = nf_put_att_text(ncid, NF_GLOBAL, "geospatial_lon_max",5, "180.0")
         iret = nf_put_att_text(ncid, NF_GLOBAL, "geospatial_lon_min",6, "-180.0")
         iret = nf_put_att_text(ncid, NF_GLOBAL, "time_coverage_start",19, date19start)
         iret = nf_put_att_text(ncid, NF_GLOBAL, "stationDimension",7, "station")
         iret = nf_put_att_real(ncid, NF_GLOBAL, "missing_value", NF_FLOAT, 1, -9E15)
!         iret = nf_put_att_int(ncid, NF_GLOBAL, "stream order output",NF_INT,1,order_to_write)
       date19(1:19) = "0000-00-00_00:00:00"
       date19(1:len_trim(date)) = date
       iret = nf_put_att_text(ncid, NF_GLOBAL, "time_coverage_end", 19, date19)


         iret = nf_enddef(ncid)
        
        !-- write latitudes
         iret = nf_inq_varid(ncid,"latitude", varid)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/), chanlat)


        !-- write longitudes
         iret = nf_inq_varid(ncid,"longitude", varid)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/), chanlon)


        !-- write elevations
         iret = nf_inq_varid(ncid,"altitude", varid)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/), elevation)

     endif

     output_count = output_count + 1


         iret = nf_inq_varid(ncid,"streamflow", varid)
         !iret = nf_put_var_real(ncid, varid,  qlink(:,1))
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/),  qlink(:,1))

!         iret = nf_inq_varid(ncid,"streamflow2d", varid)
!         iret = nf_put_vara_real(ncid, varid, (/1,1/), (/nstations,1/),  qlink(:,1))

         iret = nf_inq_varid(ncid,"streamflowMax", varid)
         !iret = nf_put_var_real(ncid, varid, qlinkMax)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/),  qlinkMax)

         iret = nf_inq_varid(ncid,"acc_streamflowMax", varid)
         !iret = nf_put_var_real(ncid, varid, accqlinkMax)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/),  accqlinkMax)

         iret = nf_inq_varid(ncid,"head", varid)
         !iret = nf_put_var_real(ncid, varid, hlink)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/),  hlink)

         iret = nf_inq_varid(ncid,"cvolume", varid)
         !iret = nf_put_var_real(ncid, varid, cvol)
         iret = nf_put_vara_real(ncid, varid, (/1/), (/nstations/),  cvol)

         iret = nf_inq_varid(ncid,"order", varid)
         !iret = nf_put_var_int(ncid, varid,  ORDER)
         iret = nf_put_vara_int(ncid, varid, (/1/), (/nstations/),  order)

         iret = nf_inq_varid(ncid,"sta", varid)
         iret = nf_put_var_int(ncid, varid,  station_id)

         iret = nf_inq_varid(ncid,"chFloodMsk", varid)
         !iret = nf_put_var_int(ncid, varid,  chFloodMsk)
         iret = nf_put_vara_int(ncid, varid, (/1/), (/nstations/),  chFloodMsk)

         iret = nf_inq_varid(ncid,"chFloodMsk_acc", varid)
         !iret = nf_put_var_int(ncid, varid,  chFloodMsk_acc)
         iret = nf_put_vara_int(ncid, varid, (/1/), (/nstations/),  chFloodMsk_acc)

        iret = nf_inq_varid(ncid,"time", varid)
        seconds_since = int(nlst_rt(1)%dt*(rt_domain(1)%out_counts-1))
        iret = nf_put_vara_int(ncid, varid, (/1/), (/1/), seconds_since)


! added by Wei Yu
     inquire (file='stat_out_stream.txt', exist=fexist) 
     if(fexist) then 
        open (unit=666,file='stat_out_stream.txt',status='unknown',position='append')
        open (unit=999,file='stat.txt',status='old',err=992)
        read(999,*,end=992) st_name
991     read(999,*,end=992) st_index, st_lon, st_lat, st_name
           write(666,'(I8,1x,f12.5,1x,f12.5,1x,f12.2,1x,A12,1x,I3,A80)') st_index, st_lon, st_lat,qlink(st_index,1),   &
               date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16), order(st_index), &
               trim(st_name)
        goto 991
992     continue
        close(999)
        close(666)
     endif

!end

      !-- lastChild variable gives the record number of the most recent report for the station
!      iret = nf_inq_varid(ncid,"lastChild", varid)
!      iret = nf_put_vara_int(ncid, varid, (/1/), (/nstations/), rec_num_of_station)

      !-- lastChild variable gives the record number of the most recent report for the station

!      iret = nf_redef(ncid)
!      date19(1:19) = "0000-00-00_00:00:00"
!      date19(1:len_trim(date)) = date
!      iret = nf_put_att_text(ncid, NF_GLOBAL, "time_coverage_end", 19, date19)


!      iret = nf_enddef(ncid)
!      iret = nf_sync(ncid)


      if (output_count == split_output_count) then
        output_count = 0
        iret = nf_close(ncid)
     endif

     deallocate(chanlat)
     deallocate(chanlon)
     deallocate(elevation)
     deallocate(station_id)
     deallocate(lOrder)
     deallocate(rec_num_of_station)


20 format(i8,',',f12.7,',',f10.7,',',f6.2,',',i3)

end subroutine output_chrt0

      subroutine lndRealRead_rami (fileName,var,out_buff,ii,jj)
!         use module_mpp_land, only: decompose_data_real, my_id, io_id, global_nx, global_ny
!         use module_HYDRO_io, only: get2d_real
!         implicit none
!         character(len=*) :: fileName, var
!         integer:: ii, jj, status
!         real,intent(out),dimension(ii,jj) :: out_buff
!         real,allocatable,dimension(:,:) :: g_buff
!         if(my_id .eq. io_id) then 
!             allocate(g_buff(global_nx,global_ny))
!             status = get2d_real(trim(var),g_buff,global_nx,global_ny,trim(fileName))
!         else
!             allocate(g_buff(1,1))
!         endif 
!         call decompose_data_real (g_buff, out_buff)
!         deallocate(g_buff)

          use module_HYDRO_io, only: get2d_lsm_real
          implicit none
          character(len=*) :: fileName, var
          integer :: ii,jj
          real,dimension(ii,jj) :: out_buff
          call get2d_lsm_real(trim(var),out_buff,ii,jj,trim(fileName) )
      end subroutine lndRealRead_rami 

!!!! need g_var to be allocated as gnlinks for all PE
      subroutine crt_stream_decomp_drv(var_out,n,g_var,gnlinks)
         use module_RT_data, only: rt_domain
         use module_mpp_land, only: crt_stream_decomp
         implicit none 
         integer :: did, n, gnlinks
         real,dimension(n) :: var_out
         real,dimension(gnlinks) :: g_var
         did = 1
         call crt_stream_decomp(var_out,n,g_var,gnlinks,rt_domain(did)%map_l2g)
      end subroutine crt_stream_decomp_drv

      subroutine read_crtgrd_1dreal_rami(varName,fileName,var_out,nlinks)
         use module_RT_data, only: rt_domain
         use module_HYDRO_io, only: read_crtgrd_1dreal, read_rst_crt_stream_nc
         implicit none 

!#include <netcdf.inc>
!         integer:: ncid, iret

         integer :: did, nlinks, gnlinks
         character(len=*) :: varName, fileName
         real, dimension(nlinks) :: var_out
         did = 1

         call read_crtgrd_1dreal(trim(varName), trim(fileName), var_out , nlinks,  &
             rt_domain(did)%map_l2g, rt_domain(did)%gnlinks)

!         iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
!         call read_rst_crt_stream_nc(ncid,var_out,NLINKS,trim(varName),rt_domain(did)%GNLINKS,rt_domain(did)%map_l2g)
!         iret = nf_close(ncid)
      end subroutine read_crtgrd_1dreal_rami

      subroutine output_tmp(var,nlinks)
         use module_RT_data, only: rt_domain
         use module_mpp_land, only: my_id, io_id
         use module_HYDRO_io, only: write_chanel_real
         implicit none
         integer :: nlinks, did
         real, dimension(nlinks) :: var
         real, allocatable,dimension(:) :: g_var
         did = 1
         allocate(g_var(rt_domain(did)%gnlinks))
         call write_chanel_real(var,rt_domain(did)%map_l2g,rt_domain(did)%gnlinks,nlinks,g_var)
         if(my_id .eq. io_id) then 
               write(51,*) g_var
         endif
         deallocate(g_var)
      end subroutine output_tmp

      subroutine sortNodeReal(from_node,var,gnlinks)
          implicit none
          integer :: gnlinks, k, m
          integer,dimension(gnlinks) :: from_node
          real,dimension(gnlinks) :: var, tmp
          tmp = var
          do k = 1, gnlinks
             m = from_node(k) 
             if(m .lt. 0 .or. m .gt. gnlinks) then 
                 write(6,*)  "Fatail error: m = ", m
                 call hydro_stop() 
             endif
             var(m) = tmp(k)
          enddo 
      end subroutine sortNodeReal

      subroutine sortNodeInt(from_node,var,gnlinks)
          implicit none
          integer :: gnlinks, k, m
          integer,dimension(gnlinks) :: from_node
          integer,dimension(gnlinks) :: var, tmp
          tmp = var
          do k = 1, gnlinks
             m = from_node(k) 
             if(m .lt. 0 .or. m .gt. gnlinks) then 
                 write(6,*)  "Fatail error: m = ", m
                 call hydro_stop() 
                 
             endif
             var(m) = tmp(k)
          enddo 
      end subroutine sortNodeInt

     subroutine chrt_io_switch_int(vio,gid,gnlinks)
         implicit none
         integer :: i,id,gnlinks
         integer, dimension(gnlinks) :: gid
         integer, dimension(gnlinks) :: vio, tmp

         tmp = vio
         do  i = 1, gnlinks
            id = gid(i)
            if(id .gt. 0 .and. id .le. gnlinks) then
                vio(id) = tmp(i) 
            endif
         enddo
     end subroutine chrt_io_switch_int
     subroutine chrt_io_switch_real(vio,gid,gnlinks)
         implicit none
         integer :: i,id,gnlinks
         integer, dimension(gnlinks) :: gid
         real, dimension(gnlinks) :: vio, tmp
         tmp = vio
         do  i = 1, gnlinks
            id = gid(i)
            if(id .gt. 0 .and. id .le. gnlinks) then
              vio(id) = tmp(i) 
            endif
         enddo
     end subroutine chrt_io_switch_real
  
      subroutine dumphead()
         use module_rt_data, only: rt_domain
          implicit none
          character(len=38) ::str
          integer :: unit0, k
          unit0 = 66
          open(unit=unit0,file="out1.kml", form="formatted")

          str='<?xml version="1.0" encoding="UTF-8"?>'
          !write(unit0,*) '<?xml version="1.0" encoding="UTF-8"?>'
          write(unit0,"(a38)") trim(str)
          write(unit0,*) '<kml xmlns="http://www.opengis.net/kml/2.2">'
          write(unit0,*) '  <Document> '
          write(unit0,*) '<Style id="red">'
          write(unit0,*) '<IconStyle>'
          write(unit0,*) '<Icon>'
          write(unit0,*) '<href>http://www.google.com/intl/en_us/mapfiles/ms/icons/red-dot.png</href>'
          write(unit0,*) '</Icon>'
          write(unit0,*) '</IconStyle>'
          write(unit0,*) '</Style>'

          write(99,*) "to node           from node "
          do k = 1, rt_domain(1)%nlinks
             write(99,*) rt_domain(1)%to_node(k), rt_domain(1)%from_node(k)
             call outputSingel(rt_domain(1)%chlat(k), rt_domain(1)%chlon(k),1,1.,rt_domain(1)%from_node(k),1,1)
          end do

          close(99)

          write(unit0,*) '  </Document> '
          write(unit0,*) '  </kml> '
          close(unit0)
      end subroutine dumphead


      subroutine outputSingel(latin , lonin ,orderin ,fcstin, k, ii0, jj0)
          implicit none
          real:: latin, lonin, fcstin
          integer:: orderin, k, ii0, jj0
          integer :: unit0
          unit0 = 66

          write(unit0,*) '<Placemark>'
          write(unit0,*) '<name>',k,'</name>'
          write(unit0,*) '<description>'
          write(unit0,*) latin,",", lonin,",", orderin,",(ii,jj)",  ii0, ",",jj0
          write(unit0,*) '</description>'
          write(unit0,*) '<Point>'
          write(unit0,*)  '   <coordinates>'
          write(unit0,*) lonin, ",",latin
          write(unit0,*) '</coordinates>'
          write(unit0,*) '</Point>'
          write(unit0,*) '</Placemark>'
      end subroutine outputSingel

subroutine lltoxy_generic (xlat,xlon,x,y,&
     project,dskm,reflat,reflon,refx,refy,&
     cenlon,truelat1,truelat2)

!*****************************************************************************!
!  Notes    - Modeled after XYTOLL in the plots.o library                     !
!*****************************************************************************!

  implicit none

! Input: ---------------------------------------------------------------------!

  real ::             xlat       ! latitude of the point of interest.
  real ::             xlon       ! longitude of the point of interest.
  character(LEN=2) :: project    ! projection indicator ("ME", "CE", "LC", "ST")
  real ::             dskm         ! grid distance in km
  real ::             reflat
  real ::             reflon
  real ::             refx
  real ::             refy
  real ::             cenlon     ! Grid ratio with respect to MOAD
  real ::             truelat1   ! True latitude 1, closest to equator
  real ::             truelat2   ! True latitude 2, closest to pole

! Output: --------------------------------------------------------------------!

  real ::             x          ! x location of the given (lat,lon) point
  real ::             y          ! y location of the given (lat,lon) point

!  Parameters: ---------------------------------------------------------------!

  real, parameter :: pi = 3.141592653589793   ! you know!  pi = 180 degrees
  real, parameter :: piovr2 = pi/2.
!  real, parameter :: re = 6370.949     ! the radius of the earth in km
  real, parameter :: re = 6371.2       ! the radius of the earth in km
  real, parameter :: ce = 2.*pi*re     ! the circumference of the earth in km
  real, parameter :: degrad = pi/180.

!  Real variables: -----------------------------------------------------------!

  real          :: flat1
  real          :: confac            ! cone factor
  real          :: rcln              ! center longitude in radians  (local)
  real          :: dj                ! distance from pole to point  (local)
  real          :: di                ! distance from the central
                                     !  meridian to the point        (local)
  real          :: bm                ! calculation variable         (local)

  real :: rflt, rfln, rlat, rlon, diovrdj, disdjs, ri, rj
  real :: ct1, st1, tt1, drp
  real :: isn, pi2
  real :: londiff

!****************************  subroutine begin  *****************************!


  rlat =  xlat * degrad
  rlon =  xlon * degrad
  rcln = cenlon * degrad
  flat1 = truelat1 * degrad
  rflt = reflat * degrad
  rfln = reflon * degrad

  if ((xlon - cenlon) < -180) then
     londiff = ((xlon-cenlon)+360.)*degrad
  else if ((xlon - cenlon) > 180) then
     londiff = ((xlon-cenlon)-360.)*degrad
  else
     londiff = (xlon-cenlon)*degrad
  endif
     

  if (project(1:2) .eq. 'ME') then

     ct1 = re*cos(flat1)
     dj = ct1 * log(tan (0.5*(rlat + piovr2)))
     di = ct1 * (rlon - rfln)
     y = refy +(dj + ct1 * log(cos(rflt)/(1 + sin(rflt))))/dskm
     x = refx + di/dskm

  else if (project(1:2) .eq. 'CE') then

!KWM     dj = re*(rlat-rflt)
!KWM     di = re*(rlon-rfln)
!KWM     y = refy + dj/dskm
!KWM     x = refx + di/dskm
     
     ! NOTE:  Cylindrical Equidistant grid increment expressed in terms 
     ! of thousandths of degrees!
     !  Calculate the distance from the horizontal axis to (J,I)
     dj = xlat-reflat
     di = xlon-reflon
     y = refy + (dj/dskm)
     x = refx + (di/dskm)

  else if (project(1:2) .eq. 'LC') then

     isn = sign(1.0, truelat2)
     pi2 = piovr2*isn

     call lccone(truelat1,truelat2,int(sign(1.0, truelat2)),confac)
     tt1 = tan((pi2 - flat1)*0.5) ! Tangent Term 1.
     st1 = sin (pi2 - flat1) * re/(confac*dskm)     ! Sine Term 1.
     bm =  tan((pi2 - rlat)*0.5)
     if ((rlon-rcln) > pi) then
        diovrdj = -tan(((rlon-rcln)-2.*pi)*confac)
     elseif ((rlon-rcln) < -pi) then
        diovrdj = -tan(((rlon-rcln)+2.*pi)*confac)
     else
        diovrdj = -tan((rlon-rcln)*confac)
     endif
     disdjs = ( (bm/tt1)**confac * st1)**2
     ! Dj: y distance (km) from pole to given x/y point.
     dj = -sqrt(disdjs/(1+diovrdj*diovrdj))
     ! Di: x distance (km) from central longitude to given x/y point.
     di = dj * diovrdj

     bm = tan((pi2-rflt)*0.5)
     if ((rfln-rcln) > pi) then
        diovrdj = -tan(((rfln-rcln)-2.*pi)*confac)
     else if ((rfln-rcln) < -pi) then
        diovrdj = -tan(((rfln-rcln)+2.*pi)*confac)
     else
        diovrdj = -tan((rfln - rcln)*confac)
     endif
     disdjs = ( (bm/tt1)**confac * st1)**2
     ! Rj: y distance (km) from pole to reference point.
     rj = -sqrt(disdjs/(1+diovrdj*diovrdj))
     ! Ri: x distance (km) from central longitude to reference x/y point.
     ri = rj * diovrdj
     y = refy + isn*(dj - rj)
     x = refx + (di - ri)

  else if (project(1:2) .eq. 'ST') then

     isn = sign(1.0, truelat1)
     pi2 = piovr2*isn

     diovrdj = -tan(rfln-rcln)
     bm = (re/dskm)*tan(0.5*(pi2-rflt))
     disdjs = (bm*(1.0 + cos(pi2-flat1)))**2
     ! RJ:  Distance from pole to reference latitude along the center lon
     rj = -sign(sqrt(disdjs/(1+diovrdj**2)),cos(rfln-rcln))
     ! RI:  Distance from center reference to requested point rlat, rlon.
     ri = rj * diovrdj
     diovrdj = -tan(rlon-rcln)
     bm = (re/dskm)*tan(0.5*(pi2-rlat))
     disdjs = (bm*(1.0 + cos(pi2-flat1)))**2
     dj = -sign(sqrt(disdjs/(1+diovrdj**2)),cos(rlon-rcln))
     di = dj * diovrdj
     y = refy + isn*(dj-rj)
     x = refx + (di-ri)
  endif

!*****************************  Subroutine End  ******************************!

end subroutine lltoxy_generic

        integer function get2d_real_file(var_name,out_buff,ix,jx,fileName )
          implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid,ix,jx
          real out_buff(ix,jx)
          character(len=*), intent(in) :: var_name
          character(len=*), intent(in) :: fileName
          character(len=256) :: errMsg
          

          get2d_real_file = -1

          iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
          if (iret .ne. 0) then
             errMsg = "get2d_real: failed to open the netcdf file: " // trim(fileName)
             write(6,*)  trim(errMsg)
             out_buff = -9999.
             return 
          endif

          ivar = nf_inq_varid(ncid,trim(var_name),  varid)
          if(ivar .ne. 0) then
             ivar = nf_inq_varid(ncid,trim(var_name//"_M"),  varid)
             if(ivar .ne. 0) then
                errMsg = "get2d_real: failed to find the variables: " //      &
                         trim(var_name) // ' and ' // trim(var_name//"_M") // &
                         ' in ' // trim(fileName)
                write(6,*) errMsg
                return 
             endif
          end if

          iret = nf_get_var_real(ncid, varid, out_buff)
          if(iret .ne. 0) then
             errMsg = "get2d_real: failed to read the variable: " // &
                      trim(var_name) // ' or ' // trim(var_name//"_M") // &
                      ' in ' // trim(fileName)
             write(6,*) trim(errMsg)
             return
          endif

          iret = nf_close(ncid)
          if(iret .ne. 0) then
             errMsg = "get2d_real: failed to close the file: " // &
                      trim(fileName)
             write(6,*) trim(errMsg)
          endif
          get2d_real_file =  ivar
      end function get2d_real_file

        subroutine get2d_int_file(var_name,out_buff,ix,jx,fileName )
          implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid,ix,jx
          integer,dimension(ix,jx) :: out_buff
          character(len=*), intent(in) :: var_name
          character(len=*), intent(in) :: fileName
          character(len=256) :: errMsg



          iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
          if (iret .ne. 0) then
             errMsg = "get2d_real: failed to open the netcdf file: " // trim(fileName)
             write(6,*)  trim(errMsg)
             out_buff = -9999.
                 call hydro_stop() 
             return
          endif

          ivar = nf_inq_varid(ncid,trim(var_name),  varid)
          if(ivar .ne. 0) then
             ivar = nf_inq_varid(ncid,trim(var_name//"_M"),  varid)
             if(ivar .ne. 0) then
                errMsg = "get2d_real: failed to find the variables: " //      &
                         trim(var_name) // ' and ' // trim(var_name//"_M") // &
                         ' in ' // trim(fileName)
                write(6,*) errMsg
                 call hydro_stop() 
                return
             endif
          end if

          iret = nf_get_var_int(ncid, varid, out_buff)
          if(iret .ne. 0) then
             errMsg = "get2d_real: failed to read the variable: " // &
                      trim(var_name) // ' or ' // trim(var_name//"_M") // &
                      ' in ' // trim(fileName)
             write(6,*) trim(errMsg)
                 call hydro_stop() 
             return
          endif

          iret = nf_close(ncid)
          if(iret .ne. 0) then
             errMsg = "get2d_real: failed to close the file: " // &
                      trim(fileName)
             write(6,*) trim(errMsg)
          endif
      end subroutine get2d_int_file

subroutine lccone (fsplat,ssplat,sign,confac)
  real, parameter :: conv=0.01745329251994
  integer :: sign
  real :: fsplat,ssplat,confac
  if (abs(fsplat-ssplat).lt.1.E-2) then
     confac = sin(fsplat*conv)
  else
     confac = log10(cos(fsplat*conv))-log10(cos(ssplat*conv))
     confac = confac/(log10(tan((45.-float(sign)*fsplat/2.)*conv))-&
          log10(tan((45.-float(sign)*ssplat/2.)*conv)))
  endif
end subroutine lccone

subroutine lccone8 (fsplat,ssplat,sign,confac)
  real*8, parameter :: conv=0.01745329251994
  integer :: sign
  real*8 :: fsplat,ssplat,confac
  if (abs(fsplat-ssplat).lt.1.E-2) then
     confac = sin(fsplat*conv)
  else
     confac = log10(cos(fsplat*conv))-log10(cos(ssplat*conv))
     confac = confac/(log10(tan((45.-float(sign)*fsplat/2.)*conv))-&
          log10(tan((45.-float(sign)*ssplat/2.)*conv)))
  endif
end subroutine lccone8

        subroutine get2d_real_lnd_mp(var_name,out_buff,ix,jx,fileName)
          use module_mpp_land, only: decompose_data_real
          use module_mpp_land, only: my_id, io_id ,global_rt_nx, global_rt_ny, global_nx, global_ny
          implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid,ix,jx
          real, dimension(ix,jx) :: out_buff
          real,dimension(global_nx, global_ny) :: g_buff
          character(len=*), intent(in) :: var_name
          character(len=*), intent(in) :: fileName
          logical :: fatalErr
          logical :: fatalErr_local
          character(len=256) :: errMsg
         
          fatalErr_local = .true.
          if(my_id .eq. io_id) then
             iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
             if (iret .ne. 0) then
                errMsg = "get2d_real_lnd: failed to open the netcdf file: " // trim(fileName)
                write(6,*)  trim(errMsg)
                if(fatalErr_local) call hydro_stop(trim(errMsg))
                out_buff = -9999.
                return 
             endif
             ivar = nf_inq_varid(ncid,trim(var_name),  varid)
             if(ivar .ne. 0) then
                ivar = nf_inq_varid(ncid,trim(var_name//"_M"),  varid)
                if(ivar .ne. 0) then
                   errMsg = "get2d_real_lnd: failed to find the variables: " //      &
                         trim(var_name) // ' and ' // trim(var_name//"_M") // &
                         ' in ' // trim(fileName)
                write(6,*) errMsg
                if(fatalErr_local) call hydro_stop(errMsg)
                   return 
                endif
             end if
             iret = nf_get_var_real(ncid, varid, g_buff)
             if(iret .ne. 0) then
                errMsg = "get2d_real_lnd: failed to read the variable: " // &
                      trim(var_name) // ' or ' // trim(var_name//"_M") // &
                      ' in ' // trim(fileName)
                write(6,*) trim(errMsg)
                if(fatalErr_local) call hydro_stop(trim(errMsg))
                return
             endif

             iret = nf_close(ncid)
          endif

          call decompose_data_real (g_buff, out_buff)
      end subroutine get2d_real_lnd_mp

        subroutine get2d_real_rt_lnd_mp(var_name,out_buff,ix,jx,fileName)
          use module_mpp_land, only: decompose_RT_real
          use module_mpp_land, only: my_id, io_id ,global_rt_nx, global_rt_ny, global_nx, global_ny
          implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid,ix,jx
          real, dimension(ix,jx) :: out_buff
          character(len=*), intent(in) :: var_name
          character(len=*), intent(in) :: fileName
          character(len=256) :: errMsg
          real,allocatable,dimension(:,:) :: g_buff
        
          write(6,*) "in get2d_real_rt_lnd_mp ix,jx ", ix,jx, trim(var_name)," ",trim(fileName)
            

          if(my_id .eq. io_id) then 
             allocate(g_buff(global_rt_nx, global_rt_ny))
          else
             allocate(g_buff(1, 1))
          endif
          if(my_id .eq. IO_id) then

             iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
             if (iret .ne. 0) then
                errMsg = "get2d_real_lnd: failed to open the netcdf file: " // trim(fileName)
                write(6,*)  trim(errMsg)
                call hydro_stop(trim(errMsg))
             endif

             ivar = nf_inq_varid(ncid,trim(var_name),  varid)
             if(ivar .ne. 0) then
                write(6,*)  "could not find the variable ", trim(var_name)
                write(6,*)  "Error ignored, failed to find variable from ", trim(fileName)
                call hydro_stop(trim(errMsg))
             end if

             iret = nf_get_var_real(ncid, varid, g_buff)
             if(iret .ne. 0) then
                call hydro_stop(trim(errMsg))
             endif
             iret = nf_close(ncid)
          endif

          call decompose_RT_real(g_buff, out_buff,global_rt_nx, global_rt_ny, ix, jx)

          if(allocated(g_buff)) deallocate(g_buff)

      end subroutine get2d_real_rt_lnd_mp
      
      
    subroutine output_factor(tmpFile,var)
        use module_mpp_land, only: my_id, io_id ,global_rt_nx, global_rt_ny, global_nx, global_ny
       implicit none
#include <netcdf.inc>
       real :: var
       integer, dimension(1) :: dim1
       integer, dimension(2) :: dim2
       integer :: ncid, iret, idim_id, jdim_id, node_id, varid
       real,dimension(global_rt_nx, global_rt_ny) :: g_buff
       integer,dimension(global_rt_nx, global_rt_ny) :: g_buff_int
       character(len=*) :: tmpFile

       if(my_id .eq. IO_id) then
          g_buff = var

          iret = nf_create(trim(tmpFile), 0, ncid)
          iret = nf_def_dim(ncid, "global_rt_nx", global_rt_nx,idim_id)
          iret = nf_def_dim(ncid, "global_rt_ny", global_rt_ny,jdim_id)
          dim2(1) = idim_id
          dim2(2) = jdim_id
          iret = nf_def_var(ncid,"factor",NF_FLOAT,2,dim2,varid)
          iret = nf_def_var(ncid,"forcingMask",NF_FLOAT,2,dim2,varid)
          iret = nf_def_var(ncid,"factor_av",NF_FLOAT,2,dim2,varid)
          iret = nf_def_var(ncid,"n_factor_av",NF_INT,2,dim2,varid)
          iret = nf_enddef(ncid)

          iret = nf_inq_varid(ncid,"factor",varid)
          where(g_buff .le. 0) g_buff = 1
          iret = nf_put_var_real(ncid,varid,g_buff)

          iret = nf_inq_varid(ncid,"factor_av",varid)
          iret = nf_put_var_real(ncid,varid,g_buff)

          iret = nf_inq_varid(ncid,"forcingMask",varid)
          iret = nf_put_var_real(ncid,varid,g_buff)
       
          g_buff_int = 0
          iret = nf_inq_varid(ncid,"n_factor_av",varid)
          iret = nf_put_var_int(ncid,varid,g_buff_int)
          iret=nf_close(ncid)
       endif
      return
    end subroutine output_factor

    subroutine outHybridForcing(forcingOpt,g_forcingMask,g_factor2d,ixrt,jxrt)
         implicit none
#include <netcdf.inc>
         integer :: forcingOpt, ixrt,jxrt
         integer :: iret,ncid2, varid
         real,dimension(ixrt,jxrt) :: g_forcingMask,g_factor2d
         
                 iret = nf_open("factor.nc", NF_WRITE, ncid2)

                if(forcingOpt .eq. 13 .or. forcingOpt .eq. 3) then  !! hybrid forcing
                   iret = nf_inq_varid(ncid2,"forcingMask", varid)
                   iret = nf_put_var_real(ncid2,varid,g_forcingMask)
                endif

                iret = nf_inq_varid(ncid2,"factor", varid)
                where(g_factor2d .le. 0) g_factor2d = 1
                iret = nf_put_var_real(ncid2,varid,g_factor2d)
                iret = nf_close(ncid2)
    end subroutine outHybridForcing

   subroutine output_lakes_rami(n_lakes, &
         date, latlake, lonlake, elevlake, &
        qlakei,qlakeo, resht,inflow_river_acc,lakeinAllBase,lakeOutAll,obslakeout)

!!output the routing variables over just channel
     implicit none
     integer,                                  intent(in) :: n_lakes
     real, dimension(n_lakes),                  intent(in) :: latlake,lonlake,elevlake,resht
     real, dimension(n_lakes),                  intent(in) :: qlakei,qlakeo  !-- inflow and outflow of lake
     real*8, dimension(n_lakes),                intent(in) :: inflow_river_acc  ! accumulated inflow of lake from river
     real*8, dimension(n_lakes)                            :: inflow_total_acc  ! accumulated total inflow of lake 
     real*8, dimension(n_lakes)                            :: lakeinAllBase,lakeOutAll
     real, dimension(n_lakes)                            :: obslakeout

     character(len=*),                         intent(in) :: date

     integer :: ncid, iret

     integer :: dimdata, varid, charid, n, lake_dimid
     character(len=256) :: output_flnm

#include <netcdf.inc>



     if(n_lakes .le. 0) return



      write(output_flnm, '(A12,".LAKEOUT_DOMAIN0")') date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16)

       iret = nf_create(trim(output_flnm), 0, ncid)

      if (iret /= 0) then
          call hydro_stop("In output_lakes() - Problem nf_create")
      endif

      iret = nf_def_dim(ncid, "numlakes", n_lakes, lake_dimid)

      !- lake location definition,  lat
      iret = nf_def_var(ncid,"latitude",NF_FLOAT, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'long_name',13,'Lake latitude')
      iret = nf_put_att_text(ncid,varid,'units',13,'degrees_north')

      !- station location definition,  long
      iret = nf_def_var(ncid,"longitude",NF_FLOAT, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'long_name',14,'Lake longitude')
      iret = nf_put_att_text(ncid,varid,'units',12,'degrees_east')

!     !- water surface elevation
      iret = nf_def_var(ncid, "wse", NF_FLOAT, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',6,'meters')
      iret = nf_put_att_text(ncid,varid,'long_name',23,'Water Surface Elevation')

!     !- inflow to lake
      iret = nf_def_var(ncid, "inflow", NF_FLOAT, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')

!     !- outflow to lake
      iret = nf_def_var(ncid, "outflow", NF_FLOAT, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 / sec')

!     !- accumulated inflow to lake from river flow
      iret = nf_def_var(ncid, "inflow_river_acc", NF_DOUBLE, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 ')

!     !- accumulated total lakein   river inflow + base in
      iret = nf_def_var(ncid, "lakein_total_acc", NF_DOUBLE, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 ')

!     !- lake in/out balance from model start
      iret = nf_def_var(ncid, "dlakeAll", NF_DOUBLE, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3')
      iret = nf_put_att_text(ncid,varid,'description',30,'in/out balance')

      iret = nf_def_var(ncid, "base_total_acc", NF_DOUBLE, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 ')

      iret = nf_def_var(ncid, "lakeOutAll_acc", NF_DOUBLE, 1, lake_dimid, varid)
      iret = nf_put_att_text(ncid,varid,'units',13,'meter^3 ')

      iret = nf_put_att_real(ncid, NF_GLOBAL, "missing_value", NF_FLOAT, 1, -9E15)
        iret = nf_enddef(ncid)

        !-- write latitudes
        iret = nf_inq_varid(ncid,"latitude", varid)
        iret = nf_put_vara_real(ncid, varid, (/1/), (/n_lakes/), LATLAKE)

        !-- write longitudes
        iret = nf_inq_varid(ncid,"longitude", varid)
        iret = nf_put_vara_real(ncid, varid, (/1/), (/n_lakes/), LONLAKE)

! 
        iret = nf_inq_varid(ncid,"wse", varid)
        iret = nf_put_vara_real(ncid, varid, (/1/), (/n_lakes/), resht)

        iret = nf_inq_varid(ncid,"inflow", varid)
        iret = nf_put_vara_real(ncid, varid, (/1/), (/n_lakes/), qlakei)

        iret = nf_inq_varid(ncid,"outflow", varid)
        iret = nf_put_vara_real(ncid, varid, (/1/), (/n_lakes/), qlakeo)

        iret = nf_inq_varid(ncid,"inflow_river_acc", varid)
        iret = nf_put_vara_double(ncid, varid, (/1/), (/n_lakes/), inflow_river_acc)

        iret = nf_inq_varid(ncid,"dlakeAll", varid)
        iret = nf_put_vara_double(ncid, varid, (/1/), (/n_lakes/), lakeinAllBase+inflow_river_acc-lakeOutAll)

        iret = nf_inq_varid(ncid,"lakein_total_acc", varid)
        iret = nf_put_vara_double(ncid, varid, (/1/), (/n_lakes/), lakeinAllBase+inflow_river_acc)

        iret = nf_inq_varid(ncid,"base_total_acc", varid)
        iret = nf_put_vara_double(ncid, varid, (/1/), (/n_lakes/), lakeinAllBase)

        iret = nf_inq_varid(ncid,"lakeOutAll_acc", varid)
        iret = nf_put_vara_double(ncid, varid, (/1/), (/n_lakes/), lakeOutAll   )

        iret = nf_close(ncid)

           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"lakein_rive_all=", inflow_river_acc
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"lakein_all=", lakeinAllBase+inflow_river_acc
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"lakeout_all=", lakeOutAll
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"lakeinAllBase=", lakeinAllBase
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"QLAKEI =", QLAKEI
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"QLAKEO =", QLAKEO
           write(88,*)  date(1:4)//date(6:7)//date(9:10)//date(12:13)//date(15:16),"obsLakO=", obsLakeOut
 end subroutine output_lakes_rami

       subroutine getFileAttReal(fileName, attName, value)
         implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid
          real :: value
          character(len=*), intent(in) ::  attName
          character(len=*), intent(in) :: fileName

          iret = nf_open(trim(fileName), NF_NOWRITE, ncid)
          if (iret .ne. 0) then
            write(6,*) "failed to open the netcdf file: ",trim(fileName)
            call hydro_stop( "stop in name list check")
            return
          endif
          iret = nf_get_att_real(ncid, NF_GLOBAL, trim(attName), value)

          if(iret .ne. 0) then
               write(6,*) "Read attribute  Error file: ",trim(fileName)
          end if
          iret = nf_close(ncid)
    end subroutine getFileAttReal

    subroutine out_1d_real(fileIn,varName,var,nsize)
         implicit none
#include <netcdf.inc>
          integer :: ivar, iret,varid,ncid
          character(len=*) :: fileIn, varName
          integer :: nsize
          real,dimension(nsize) :: var
           iret = nf_open(trim(fileIn), NF_WRITE, ncid)
           iret = nf_inq_varid(ncid,trim(varName), varid)
           iret = nf_put_var_real(ncid,varid,var)
           iret=nf_close(ncid)
    end subroutine out_1d_real
