#!/bin/csh -f

source setEnvar.csh
if(! -e ../exec) mkdir ../exec

set rootDir = `pwd`

echo $NETCDF
if($status != 0) then
  echo "Error: NETCDF not defined."
  exit
endif

which mpif90 
if($status != 0) then
  echo "Error: mpif90 not defined."
  exit
endif

rm -f Run/*.exe

./configure 2

if($WRF_HYDRO != 1) then
   echo "Please set WRF_HYDRO to be 1 from setEnvar.csh"
   exit
endif
rm -f  LandModel LandModel_cpl
cp arc/Makefile.NoahMP Makefile
## if(! -e Land_models/NoahMP/MPP) then
  cd Land_models/NoahMP
  cp hydro/Makefile.hydro Makefile
  if(-e MPP) rm -rf  MPP
  ln -sf ../../MPP .
  cd ../..
## endif
ln -sf Land_models/NoahMP LandModel
cat macros LandModel/hydro/user_build_options.bak  > LandModel/user_build_options
#ln -sf CPL/NoahMP_cpl LandModel_cpl
#make clean; rm -f Run/wrf_hydro_NoahMP.exe
#rm -f librami/*.a

mv mod mod.bak
make clean
mv mod.bak mod
cp librami/*.a lib/.

#cd MPP; make clean; cd ..
#cd LandModel; make clean;make
#cd ../DHYDRO; make
#cd ../Run; make
make

cd Run
#echo $WRF_DHYDRO
grep -v "#" ../setEnvar.csh |grep WRF_DHYDRO 
if($status == 0) then
   rm -f wrf_hydro.exe wrf_hydro_NoahMP.exe dhydro.exe
else
   mv  wrf_hydro.exe wrf_hydro_NoahMP.exe; ln -sf wrf_hydro_NoahMP.exe wrf_hydro.exe
   rm -f NoahMP_dhydro.exe
endif

###set for dhydro. 
cd $rootDir
mkdir ../exec
mkdir ../run_template
# if (! -e $rootDir/../realTime/case/exec) mkdir -p $rootDir/../realTime/case/exec
# cp Run/*.exe $rootDir/../realTime/case/exec/.
cp Run/*.exe ../run_template/.
cp Run/*.exe ../exec
cd utils; make exe
# cp drv/*/*.exe $rootDir/../realTime/case/exec/.
cp drv/*/*.exe ../../run_template/.
cp drv/*/*.exe ../../exec

